(setq x-gtk-use-window-move t)

(defvar display-pixel-width (display-pixel-width))
(defvar display-pixel-height (display-pixel-height))

(defun frame-position-test-1 (frame)
  (let* ((type (frame-parameter frame 'p-type))
	 (p-left (frame-parameter frame 'p-left))
	 (p-top (frame-parameter frame 'p-top))
	 (pos (frame-position frame))
	 (left (car pos))
	 (top (cdr pos))
	 (width (frame-pixel-width frame))
	 (height (frame-pixel-height frame))
	 (list (list type
		     (cons 'p-left p-left) (cons 'p-top p-top)
		     (cons 'left left) (cons 'top top)
		     (cons 'width width) (cons 'height height))))
    (when (< p-left 0)
      (let ((r-left (+ (- display-pixel-width) left width)))
	(setq list (nconc list (list (cons 'r-left r-left))))))
    (when (< p-top 0)
      (let ((r-top (+ (- display-pixel-height) top height)))
	(setq list (nconc list (list (cons 'r-top r-top))))))
    list))

(defun frame-position-make-frame-arg (p-left p-top)
  (make-frame `((p-type . arg)
		(p-left . ,p-left) (left . ,p-left)
		(p-top . ,p-top) (top . ,p-top)
		(width . 80) (height . 20))))

(defun frame-position-make-frame-par (p-left p-top)
  (let ((frame (make-frame `((visibility . nil) (p-type . par)
			     (p-left . ,p-left) (p-top . ,p-top)))))
    (modify-frame-parameters frame `((left . ,p-left) (top . ,p-top)
				     (width . 80) (height . 20)))
    (make-frame-visible frame)))

(defun frame-position-make-frame-fun (p-left p-top)
  (let ((frame (make-frame `((visibility . nil) (p-type . fun)
			     (p-left . ,p-left) (p-top . ,p-top)))))
    (set-frame-size frame 80 20)
    (set-frame-position frame p-left p-top)
    (make-frame-visible frame)))

(defun frame-position-make ()
  (interactive)
  (let (frame)
    (dolist (frame (frame-list))
      (set-frame-parameter frame 'p-type nil)))
  (frame-position-make-frame-arg 40 40)
  (frame-position-make-frame-arg 40 -40)
  (frame-position-make-frame-arg -40 40)
  (frame-position-make-frame-arg -40 -40)
  (frame-position-make-frame-par 40 40)
  (frame-position-make-frame-par 40 -40)
  (frame-position-make-frame-par -40 40)
  (frame-position-make-frame-par -40 -40)
  (frame-position-make-frame-fun 40 40)
  (frame-position-make-frame-fun 40 -40)
  (frame-position-make-frame-fun -40 40)
  (frame-position-make-frame-fun -40 -40))

(defun frame-position-list ()
  (interactive)
  (let ((list (list (cons 'display-pixel-height display-pixel-height)
		    (cons 'display-pixel-width display-pixel-width)))
	frame)
    (dolist (frame (nreverse (frame-list)))
      (when (frame-parameter frame 'p-type)
	(setq list (cons (frame-position-test-1 frame) list))))

    list))

;; (eval-buffer)
;; (frame-position-make)
;; (insert (format "\n%s" (pp (nreverse (frame-position-list)))))
